public class MccaJaspa{
    public static final double CPU_MIN = 2.0;

    public static void main (String[] args) throws Exception
    {
	    int nrun, nz, n; 
	    long endTime;
	    long startTime = 0;
	    int[] irn;
	    int[] jcn;
	    double[] val;
	    
	    n = 180;
	    nz = 2659;
	    irn = irn_values;
	    jcn = jcn_values;
	    val = new double[nz];
	    for (int j = 0; j < nz; j++) {
		    val[j] = 1.0;
		}

	    int[] ia = new int[n+2]; //extra space for FORTRAN style
	    int[] ja = new int[nz+1]; //extra space for FORTRAN style
	    double[] a = new double[nz+1]; //extra space for FORTRAN style
	    ijval2csr(n,nz,irn,jcn,val,ia,ja,a);
	    int m = n;
	    
	    int nz1;
	    double[] c;
	    for (nrun = 1;;nrun++){
		nz1 = spmatmul_size(n, m, ia,ja, ia, ja);
	    
		// allocate space for the multiplication
		int[] ic = new int[n+2]; //extra space for FORTRAN style
		int[] jc = new int[nz1+1]; //extra space for FORTRAN style
		c = new double[nz1+1]; //extra space for FORTRAN style
		spmatmul_double(n,m,a,ia,ja,a,ia,ja,c,ic,jc);
		if (nrun > 100) break;		
	    }
	
	    // check the answer: average entry value 
	    double avg = 0;
	    for (int j = 1; j <= nz1; j++) {
		avg = avg + c[j];
	    }
	    	    
    }//end main

    public static void ijval2csr(int n, int nz, 
				 int[] irn, int[] jcn, double[] val,
				 int[] ia, int[] ja, double[] a) {
	int i,ii,jj;

	// convert to compact sparse row format     
	int[] nrow = new int[n+2];//extra space for FORTRAN style

	for (i = 1; i <= n+1; i++) {
	    nrow[i] = 0;
	}
	for (i = 0; i < nz; i++) {
	    nrow[irn[i]] = nrow[irn[i]] + 1;
	}

	ia[1] = 1;// [1]: fortran style
	for (i = 1; i <= n; i++) {
	    ia[i+1] = ia[i] + nrow[i];
	}

	for (i = 1; i <= n+1; i++) {
	    nrow[i] = ia[i];
	}
    
	for (i = 0; i < nz; i++) {
	    ii = irn[i];
	    jj = jcn[i];
	    ja[nrow[ii]] = jj;
	    a[nrow[ii]] = val[i];
	    nrow[ii] = nrow[ii] + 1;
	}
    }//end method ijval2csr


    static int spmatmul_size(int n, int m,
			     int[] ia,int[] ja,
			     int[] ib,int[] jb)

    {
	int i,j,k,nz,icol_add;


  
	int[] mask = new int[m+1]; //m=1 rather than m: fortran style

	for (i = 1; i <= m; i++) mask[i] = -1; // start from 1: fortran style


	nz = 0;
    
	for (i = 1; i <= n; i++)  // fortran style
	    {
		for (j = ia[i]; j < ia[i+1]; j++)
		    {
			int neigh = ja[j];
			for (k = ib[neigh]; k < ib[neigh+1]; k++)
			    {
				icol_add = jb[k];
				if (mask[icol_add] != i) 
				    {
					nz++;
					mask[icol_add] = i; // add mask 
				    }
			    }
		    }
	    }

	return nz;
    }

    static void spmatmul_double(    
			 int n, int m,
			 double[] a, int[] ia,int[] ja, 
			 double[] b, int[] ib,int[] jb,     
			 double[] c, int[] ic,int[] jc)
    {
	int nz;
	int i,j,k,l,icol,icol_add;
	double aij;
	int neighbour;

	int[] mask = new int[m+1]; // extra space for FORTRAN like array indexing

	for (l = 1; l <= m; l++) mask[l] = 0; // starting from one for FORTRAN like array index

	ic[0] = 1;
	nz = 0;
	for (i = 1; i <= n; i++) {   // starting from one for FORTRAN like array index
	    for (j = ia[i]; j < ia[i+1]; j++){
		neighbour = ja[j];
		aij = a[j];
		for (k = ib[neighbour]; k < ib[neighbour+1]; k++){ 
		    icol_add = jb[k];
		    icol = mask[icol_add];
		    if (icol ==  0) { 
			jc[++nz] = icol_add;
			c[nz] =  aij*b[k];
			mask[icol_add] = nz;
		    }
		    else {
			c[icol] +=  aij*b[k];
		    }
		}
	    }
	    for (j = ic[i]; j < nz + 1; j++) mask[jc[j]] = 0;
	    ic[i+1] = nz+1;
	}

    }

    static int spmatmul_flops(int n, int m,
			     int[] ia,int[] ja,
			     int[] ib,int[] jb)

    {
	int i,j,k,nz,icol_add,flops;


  
	int[] mask = new int[m+1]; //m=1 rather than m: fortran style

	for (i = 1; i <= m; i++) mask[i] = -1; // start from 1: fortran style


	nz = 0;
	flops = 0;
    
	for (i = 1; i <= n; i++)  // fortran style
	    {
		for (j = ia[i]; j < ia[i+1]; j++)
		    {
			int neigh = ja[j];
			for (k = ib[neigh]; k < ib[neigh+1]; k++)
			    {
				icol_add = jb[k];
				flops += 2;
				if (mask[icol_add] != i) 
				    {
					nz++;
					mask[icol_add] = i; // add mask 
				    }
			    }
		    }
	    }
	flops += nz;
	return flops;
    }


 static int jcn_values[] = {

    1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 
    6, 6, 6, 6, 7, 7, 7, 7, 8, 8, 8, 8, 9, 9, 9, 9, 10, 10, 10, 10, 
    11, 11, 11, 11, 12, 12, 12, 12, 13, 13, 13, 13, 13, 14, 14, 14, 14, 15, 15, 15, 
    15, 15, 16, 16, 16, 16, 17, 17, 17, 17, 17, 17, 18, 18, 18, 18, 19, 19, 19, 19, 
    19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 21, 21, 22, 22, 22, 22, 23, 23, 23, 23, 
    23, 23, 24, 24, 24, 24, 25, 25, 25, 25, 25, 25, 26, 26, 26, 26, 27, 27, 27, 27, 
    27, 27, 28, 28, 28, 28, 29, 29, 29, 29, 29, 29, 29, 29, 29, 30, 30, 30, 30, 31, 
    31, 31, 31, 31, 31, 31, 31, 31, 32, 32, 32, 32, 33, 33, 33, 33, 33, 33, 33, 33, 
    33, 33, 34, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 35, 35, 35, 36, 36, 36, 36, 
    37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 37, 38, 38, 38, 38, 38, 38, 39, 39, 39, 
    39, 39, 39, 39, 39, 39, 39, 39, 39, 40, 40, 40, 40, 41, 41, 41, 41, 41, 41, 41, 
    41, 41, 41, 41, 41, 41, 41, 41, 41, 42, 42, 42, 42, 42, 42, 42, 42, 43, 43, 43, 
    43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 43, 44, 44, 44, 44, 45, 
    45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 46, 46, 46, 46, 
    46, 46, 46, 46, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47, 
    47, 47, 47, 48, 48, 48, 48, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 49, 
    49, 49, 49, 49, 49, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 51, 51, 51, 51, 51, 
    51, 51, 51, 51, 51, 51, 51, 51, 51, 51, 51, 51, 51, 51, 51, 51, 52, 52, 52, 52, 
    53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 53, 54, 
    54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 54, 55, 55, 55, 55, 55, 55, 55, 
    55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 56, 56, 56, 
    56, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 
    58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 58, 
    58, 58, 58, 58, 58, 58, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 
    59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 59, 60, 60, 60, 60, 
    61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 62, 
    62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 
    62, 62, 62, 62, 62, 62, 62, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 
    63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 64, 64, 
    64, 64, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 
    66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 
    66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 
    67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 67, 
    67, 67, 68, 68, 68, 68, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 
    69, 69, 69, 69, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 
    70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 70, 71, 71, 71, 71, 
    71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 
    71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 71, 72, 72, 72, 72, 73, 73, 73, 73, 73, 
    73, 73, 73, 73, 73, 73, 73, 73, 73, 73, 73, 73, 74, 74, 74, 74, 74, 74, 74, 74, 
    74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 74, 
    74, 74, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 
    75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 76, 76, 76, 76, 77, 
    77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 78, 78, 78, 78, 78, 78, 
    78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 
    78, 78, 78, 78, 78, 78, 78, 78, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 
    79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 
    79, 79, 79, 79, 79, 80, 80, 80, 80, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 81, 
    81, 81, 81, 81, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 
    82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 82, 83, 83, 
    83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 
    83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 83, 84, 84, 84, 84, 85, 85, 
    85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 86, 86, 86, 86, 86, 86, 86, 
    86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 86, 
    86, 86, 86, 86, 86, 86, 86, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 
    87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 
    87, 87, 87, 87, 88, 88, 88, 88, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 89, 
    89, 89, 89, 89, 89, 89, 89, 89, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 
    90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 91, 91, 91, 91, 
    91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 
    91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 91, 92, 92, 92, 92, 93, 93, 93, 
    93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 94, 94, 94, 
    94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 
    94, 94, 94, 94, 94, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 
    95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 95, 
    95, 95, 96, 96, 96, 96, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 
    97, 97, 97, 97, 97, 97, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 
    98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 99, 99, 99, 99, 99, 99, 
    99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 
    99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 100, 100, 100, 100, 101, 101, 101, 101, 101, 101, 
    101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 102, 102, 102, 102, 102, 
    102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 102, 
    102, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 
    103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 103, 104, 104, 104, 104, 
    105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 
    105, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 
    106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 107, 107, 107, 107, 107, 107, 107, 
    107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 
    107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 108, 108, 108, 108, 109, 109, 109, 109, 109, 
    109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 110, 110, 110, 110, 110, 
    110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 
    110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 110, 111, 111, 111, 111, 111, 
    111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 
    111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 112, 112, 112, 112, 113, 
    113, 113, 113, 113, 113, 113, 113, 113, 113, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 
    114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 
    114, 114, 114, 114, 114, 114, 114, 114, 114, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 
    115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 
    115, 115, 115, 115, 115, 115, 115, 115, 115, 116, 116, 116, 116, 117, 117, 117, 117, 117, 117, 117, 
    117, 117, 117, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 
    118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 119, 
    119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 
    119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 119, 120, 120, 120, 120, 121, 
    121, 121, 121, 121, 121, 121, 121, 121, 121, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 
    122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 
    122, 122, 122, 122, 122, 122, 122, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 
    123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 
    123, 123, 123, 123, 123, 124, 124, 124, 124, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 125, 
    126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 
    126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 127, 127, 
    127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 
    127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128, 
    129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 130, 130, 130, 130, 130, 130, 130, 130, 130, 
    130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 
    130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 131, 131, 131, 131, 131, 131, 131, 131, 131, 
    131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 
    131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 132, 132, 132, 132, 133, 133, 133, 133, 133, 
    133, 133, 133, 133, 133, 133, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 
    134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 
    134, 134, 134, 134, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 
    135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 135, 
    135, 135, 136, 136, 136, 136, 137, 137, 137, 137, 137, 137, 137, 137, 137, 137, 137, 138, 138, 138, 
    138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 138, 
    138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 
    139, 139, 139, 139, 139, 140, 140, 140, 140, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 
    142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 143, 143, 
    143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 144, 144, 144, 144, 
    145, 145, 145, 145, 145, 145, 145, 145, 145, 145, 145, 146, 146, 146, 146, 146, 146, 146, 146, 146, 
    146, 146, 146, 146, 146, 146, 146, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 
    147, 147, 147, 147, 148, 148, 148, 148, 149, 149, 149, 149, 149, 149, 149, 149, 149, 149, 150, 150, 
    150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 151, 151, 151, 151, 151, 151, 
    151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 152, 152, 152, 152, 153, 153, 153, 153, 153, 153, 
    153, 153, 153, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 155, 155, 155, 
    155, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155, 156, 156, 156, 156, 157, 157, 157, 157, 157, 
    157, 157, 157, 157, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 159, 159, 
    159, 159, 159, 159, 159, 159, 159, 159, 159, 159, 159, 159, 160, 160, 160, 160, 161, 161, 161, 161, 
    161, 161, 161, 161, 161, 161, 162, 162, 162, 162, 162, 162, 162, 162, 162, 162, 162, 162, 162, 162, 
    163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 164, 164, 164, 164, 165, 
    165, 165, 165, 165, 165, 165, 165, 165, 165, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 
    166, 166, 166, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 168, 168, 
    168, 168, 169, 169, 169, 169, 169, 169, 169, 169, 169, 170, 170, 170, 170, 170, 170, 170, 170, 170, 
    170, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 172, 172, 172, 172, 173, 173, 173, 
    173, 173, 174, 174, 174, 174, 174, 174, 175, 175, 175, 175, 175, 175, 176, 176, 176, 176, 177, 177, 
    177, 177, 177, 178, 178, 178, 178, 178, 178, 179, 179, 179, 179, 179, 179, 180, 180, 180, 180};
    
    static int irn_values[] = {

    1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4, 5, 6, 7, 8, 
    5, 6, 7, 8, 5, 6, 7, 8, 5, 6, 7, 8, 9, 10, 11, 12, 9, 10, 11, 12, 
    9, 10, 11, 12, 9, 10, 11, 12, 13, 14, 15, 16, 19, 13, 14, 15, 16, 13, 14, 15, 
    16, 19, 13, 14, 15, 16, 17, 18, 19, 20, 23, 27, 17, 18, 19, 20, 17, 18, 19, 20, 
    23, 27, 17, 18, 19, 20, 21, 22, 23, 24, 27, 31, 21, 22, 23, 24, 21, 22, 23, 24, 
    27, 31, 21, 22, 23, 24, 25, 26, 27, 28, 31, 35, 25, 26, 27, 28, 25, 26, 27, 28, 
    31, 35, 25, 26, 27, 28, 19, 23, 27, 29, 30, 31, 32, 35, 39, 29, 30, 31, 32, 19, 
    23, 27, 29, 30, 31, 32, 35, 39, 29, 30, 31, 32, 19, 23, 27, 31, 33, 34, 35, 36, 
    39, 43, 33, 34, 35, 36, 19, 23, 27, 31, 33, 34, 35, 36, 39, 43, 33, 34, 35, 36, 
    23, 27, 31, 35, 37, 38, 39, 40, 43, 47, 51, 37, 38, 39, 40, 46, 47, 23, 27, 31, 
    35, 37, 38, 39, 40, 43, 46, 47, 51, 37, 38, 39, 40, 27, 31, 35, 39, 41, 42, 43, 
    44, 47, 51, 55, 59, 63, 67, 71, 75, 41, 42, 43, 44, 46, 47, 50, 51, 27, 31, 35, 
    39, 41, 42, 43, 44, 46, 47, 50, 51, 55, 59, 63, 67, 71, 75, 41, 42, 43, 44, 31, 
    35, 39, 43, 45, 46, 47, 48, 51, 55, 59, 63, 67, 71, 75, 79, 83, 45, 46, 47, 48, 
    50, 51, 54, 55, 31, 35, 39, 43, 45, 46, 47, 48, 50, 51, 54, 55, 59, 63, 67, 71, 
    75, 79, 83, 45, 46, 47, 48, 35, 39, 43, 47, 49, 50, 51, 52, 55, 59, 63, 67, 71, 
    75, 79, 83, 87, 91, 49, 50, 51, 52, 54, 55, 58, 59, 62, 63, 35, 39, 43, 47, 49, 
    50, 51, 52, 54, 55, 58, 59, 62, 63, 67, 71, 75, 79, 83, 87, 91, 49, 50, 51, 52, 
    35, 39, 43, 47, 51, 53, 54, 55, 56, 59, 63, 67, 71, 75, 79, 83, 87, 91, 95, 53, 
    54, 55, 56, 58, 59, 62, 63, 66, 67, 70, 71, 82, 83, 35, 39, 43, 47, 51, 53, 54, 
    55, 56, 58, 59, 62, 63, 66, 67, 70, 71, 75, 79, 82, 83, 87, 91, 95, 53, 54, 55, 
    56, 35, 39, 43, 47, 51, 55, 57, 58, 59, 60, 63, 67, 71, 75, 79, 83, 87, 91, 95, 
    46, 47, 50, 51, 54, 55, 57, 58, 59, 60, 62, 63, 66, 67, 70, 71, 74, 75, 78, 79, 
    82, 83, 86, 87, 90, 91, 35, 39, 43, 46, 47, 50, 51, 54, 55, 57, 58, 59, 60, 62, 
    63, 66, 67, 70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 95, 57, 58, 59, 60, 
    35, 39, 47, 51, 55, 59, 61, 62, 63, 64, 67, 71, 75, 79, 83, 87, 91, 95, 99, 46, 
    47, 50, 51, 54, 55, 58, 59, 61, 62, 63, 64, 66, 67, 70, 71, 74, 75, 78, 79, 82, 
    83, 86, 87, 90, 91, 94, 95, 35, 39, 46, 47, 50, 51, 54, 55, 58, 59, 61, 62, 63, 
    64, 66, 67, 70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 99, 61, 62, 
    63, 64, 39, 43, 51, 55, 59, 63, 65, 66, 67, 68, 71, 75, 79, 83, 87, 91, 95, 99, 
    50, 51, 54, 55, 58, 59, 62, 63, 65, 66, 67, 68, 70, 71, 74, 75, 78, 79, 82, 83, 
    86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 39, 43, 50, 51, 54, 55, 58, 59, 62, 63, 
    65, 66, 67, 68, 70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 
    102, 103, 65, 66, 67, 68, 39, 43, 47, 55, 59, 63, 67, 69, 70, 71, 72, 75, 79, 83, 
    87, 91, 95, 99, 50, 51, 54, 55, 58, 59, 62, 63, 66, 67, 69, 70, 71, 72, 74, 75, 
    78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 39, 43, 47, 50, 
    51, 54, 55, 58, 59, 62, 63, 66, 67, 69, 70, 71, 72, 74, 75, 78, 79, 82, 83, 86, 
    87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 69, 70, 71, 72, 43, 47, 55, 59, 63, 
    67, 71, 73, 74, 75, 76, 79, 83, 87, 91, 95, 99, 58, 59, 62, 63, 66, 67, 70, 71, 
    73, 74, 75, 76, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 
    110, 111, 43, 47, 55, 58, 59, 62, 63, 66, 67, 70, 71, 73, 74, 75, 76, 78, 79, 82, 
    83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 73, 74, 75, 76, 43, 
    51, 55, 67, 71, 75, 77, 78, 79, 80, 83, 87, 91, 95, 99, 58, 59, 62, 63, 66, 67, 
    70, 71, 74, 75, 77, 78, 79, 80, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 
    106, 107, 110, 111, 114, 115, 118, 119, 43, 51, 55, 58, 59, 62, 63, 66, 67, 70, 71, 74, 
    75, 77, 78, 79, 80, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 
    111, 114, 115, 118, 119, 77, 78, 79, 80, 47, 51, 67, 71, 75, 79, 81, 82, 83, 84, 87, 
    91, 95, 99, 103, 58, 59, 62, 63, 66, 67, 70, 71, 74, 75, 78, 79, 81, 82, 83, 84, 
    86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 47, 51, 
    58, 59, 62, 63, 66, 67, 70, 71, 74, 75, 78, 79, 81, 82, 83, 84, 86, 87, 90, 91, 
    94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 81, 82, 83, 84, 47, 51, 
    59, 67, 75, 79, 83, 85, 86, 87, 88, 91, 95, 99, 103, 54, 55, 66, 67, 70, 71, 74, 
    75, 78, 79, 82, 83, 85, 86, 87, 88, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 
    111, 114, 115, 118, 119, 122, 123, 47, 51, 54, 55, 59, 66, 67, 70, 71, 74, 75, 78, 79, 
    82, 83, 85, 86, 87, 88, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 
    118, 119, 122, 123, 85, 86, 87, 88, 39, 43, 47, 51, 55, 59, 63, 67, 71, 75, 79, 83, 
    87, 89, 90, 91, 92, 95, 99, 103, 54, 55, 78, 79, 82, 83, 86, 87, 89, 90, 91, 92, 
    94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 39, 43, 47, 51, 
    54, 55, 59, 63, 67, 71, 75, 78, 79, 82, 83, 86, 87, 89, 90, 91, 92, 94, 95, 98, 
    99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 89, 90, 91, 92, 39, 43, 47, 
    51, 55, 59, 63, 67, 71, 75, 79, 83, 87, 91, 93, 94, 95, 96, 99, 103, 58, 59, 74, 
    75, 82, 83, 86, 87, 90, 91, 93, 94, 95, 96, 98, 99, 102, 103, 106, 107, 110, 111, 114, 
    115, 118, 119, 122, 123, 39, 43, 47, 51, 55, 58, 59, 63, 67, 71, 74, 75, 79, 82, 83, 
    86, 87, 90, 91, 93, 94, 95, 96, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 
    122, 123, 93, 94, 95, 96, 43, 47, 51, 55, 59, 63, 67, 71, 75, 79, 83, 87, 91, 95, 
    97, 98, 99, 100, 103, 107, 58, 59, 62, 63, 74, 75, 86, 87, 90, 91, 94, 95, 97, 98, 
    99, 100, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 43, 47, 51, 55, 58, 59, 
    62, 63, 67, 71, 74, 75, 79, 83, 86, 87, 90, 91, 94, 95, 97, 98, 99, 100, 102, 103, 
    106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 97, 98, 99, 100, 43, 47, 51, 55, 59, 63, 
    67, 71, 75, 79, 83, 87, 91, 95, 99, 101, 102, 103, 104, 107, 111, 62, 63, 66, 67, 78, 
    79, 86, 87, 90, 91, 98, 99, 101, 102, 103, 104, 106, 107, 110, 111, 114, 115, 118, 119, 122, 
    123, 43, 47, 51, 55, 59, 62, 63, 66, 67, 71, 75, 78, 79, 83, 86, 87, 90, 91, 95, 
    98, 99, 101, 102, 103, 104, 106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 101, 102, 103, 104, 
    47, 51, 55, 59, 63, 67, 71, 75, 79, 83, 87, 91, 95, 99, 103, 105, 106, 107, 108, 111, 
    115, 66, 67, 70, 71, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 105, 
    106, 107, 108, 110, 111, 114, 115, 118, 119, 122, 123, 126, 127, 47, 51, 55, 59, 63, 66, 67, 
    70, 71, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 105, 106, 107, 
    108, 110, 111, 114, 115, 118, 119, 122, 123, 126, 127, 105, 106, 107, 108, 55, 59, 63, 67, 71, 
    75, 79, 83, 87, 91, 95, 99, 103, 107, 109, 110, 111, 112, 115, 119, 54, 55, 58, 59, 62, 
    63, 66, 67, 70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 
    103, 106, 107, 109, 110, 111, 112, 114, 115, 118, 119, 122, 123, 126, 127, 54, 55, 58, 59, 62, 
    63, 66, 67, 70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 
    103, 106, 107, 109, 110, 111, 112, 114, 115, 118, 119, 122, 123, 126, 127, 109, 110, 111, 112, 99, 
    103, 107, 111, 113, 114, 115, 116, 119, 123, 54, 55, 58, 59, 62, 63, 66, 67, 70, 71, 74, 
    75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 113, 
    114, 115, 116, 118, 119, 122, 123, 126, 127, 54, 55, 58, 59, 62, 63, 66, 67, 70, 71, 74, 
    75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 113, 
    114, 115, 116, 118, 119, 122, 123, 126, 127, 113, 114, 115, 116, 103, 107, 111, 115, 117, 118, 119, 
    120, 123, 127, 62, 63, 66, 67, 70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 
    95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 117, 118, 119, 120, 122, 123, 126, 127, 62, 
    63, 66, 67, 70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 
    103, 106, 107, 110, 111, 114, 115, 117, 118, 119, 120, 122, 123, 126, 127, 117, 118, 119, 120, 107, 
    111, 115, 119, 121, 122, 123, 124, 127, 131, 62, 63, 66, 67, 70, 71, 74, 75, 78, 79, 82, 
    83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 121, 
    122, 123, 124, 126, 127, 130, 131, 62, 63, 66, 67, 70, 71, 74, 75, 78, 79, 82, 83, 86, 
    87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 121, 122, 123, 
    124, 126, 127, 130, 131, 121, 122, 123, 124, 107, 111, 115, 119, 123, 125, 126, 127, 128, 131, 135, 
    66, 67, 70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 
    106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 125, 126, 127, 128, 130, 131, 134, 135, 66, 67, 
    70, 71, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 
    110, 111, 114, 115, 118, 119, 122, 123, 125, 126, 127, 128, 130, 131, 134, 135, 125, 126, 127, 128, 
    111, 115, 119, 123, 127, 129, 130, 131, 132, 135, 139, 66, 67, 70, 71, 74, 75, 78, 79, 82, 
    83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 122, 
    123, 126, 127, 129, 130, 131, 132, 134, 135, 138, 139, 66, 67, 70, 71, 74, 75, 78, 79, 82, 
    83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 122, 
    123, 126, 127, 129, 130, 131, 132, 134, 135, 138, 139, 129, 130, 131, 132, 115, 119, 123, 127, 131, 
    133, 134, 135, 136, 139, 143, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 
    102, 103, 106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 126, 127, 130, 131, 133, 134, 135, 136, 
    138, 139, 142, 143, 74, 75, 78, 79, 82, 83, 86, 87, 90, 91, 94, 95, 98, 99, 102, 103, 
    106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 126, 127, 130, 131, 133, 134, 135, 136, 138, 139, 
    142, 143, 133, 134, 135, 136, 119, 123, 127, 131, 135, 137, 138, 139, 140, 143, 147, 106, 107, 110, 
    111, 114, 115, 118, 119, 122, 123, 126, 127, 130, 131, 134, 135, 137, 138, 139, 140, 142, 143, 146, 
    147, 106, 107, 110, 111, 114, 115, 118, 119, 122, 123, 126, 127, 130, 131, 134, 135, 137, 138, 139, 
    140, 142, 143, 146, 147, 137, 138, 139, 140, 123, 127, 131, 135, 139, 141, 142, 143, 144, 147, 151, 
    122, 123, 126, 127, 130, 131, 134, 135, 138, 139, 141, 142, 143, 144, 146, 147, 150, 151, 122, 123, 
    126, 127, 130, 131, 134, 135, 138, 139, 141, 142, 143, 144, 146, 147, 150, 151, 141, 142, 143, 144, 
    127, 131, 135, 139, 143, 145, 146, 147, 148, 151, 155, 130, 131, 134, 135, 138, 139, 142, 143, 145, 
    146, 147, 148, 150, 151, 154, 155, 127, 130, 131, 134, 135, 138, 139, 142, 143, 145, 146, 147, 148, 
    150, 151, 154, 155, 145, 146, 147, 148, 135, 139, 143, 147, 149, 150, 151, 152, 155, 159, 134, 135, 
    138, 139, 142, 143, 146, 147, 149, 150, 151, 152, 154, 155, 158, 159, 134, 135, 138, 139, 142, 143, 
    146, 147, 149, 150, 151, 152, 154, 155, 158, 159, 149, 150, 151, 152, 139, 143, 147, 151, 153, 154, 
    155, 156, 159, 138, 139, 142, 143, 146, 147, 150, 151, 153, 154, 155, 156, 158, 159, 138, 139, 142, 
    143, 146, 147, 150, 151, 153, 154, 155, 156, 158, 159, 153, 154, 155, 156, 143, 147, 151, 155, 157, 
    158, 159, 160, 163, 142, 143, 146, 147, 150, 151, 154, 155, 157, 158, 159, 160, 162, 163, 142, 143, 
    146, 147, 150, 151, 154, 155, 157, 158, 159, 160, 162, 163, 157, 158, 159, 160, 143, 147, 151, 155, 
    159, 161, 162, 163, 164, 167, 146, 147, 150, 151, 154, 155, 158, 159, 161, 162, 163, 164, 166, 167, 
    143, 146, 147, 150, 151, 154, 155, 158, 159, 161, 162, 163, 164, 166, 167, 161, 162, 163, 164, 147, 
    151, 155, 159, 163, 165, 166, 167, 168, 171, 150, 151, 154, 155, 158, 159, 162, 163, 165, 166, 167, 
    168, 170, 171, 147, 150, 151, 154, 155, 158, 159, 162, 163, 165, 166, 167, 168, 170, 171, 165, 166, 
    167, 168, 155, 159, 163, 167, 169, 170, 171, 172, 175, 162, 163, 166, 167, 169, 170, 171, 172, 174, 
    175, 155, 159, 162, 163, 166, 167, 169, 170, 171, 172, 174, 175, 169, 170, 171, 172, 171, 173, 174, 
    175, 176, 170, 171, 173, 174, 175, 176, 170, 171, 173, 174, 175, 176, 173, 174, 175, 176, 175, 177, 
    178, 179, 180, 174, 175, 177, 178, 179, 180, 174, 175, 177, 178, 179, 180, 177, 178, 179, 180};
}//end Spmatmul class
